# MetaGraphs

[![Stable docs](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliagraphs.org/MetaGraphs.jl/)
[![Dev docs](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliagraphs.org/MetaGraphs.jl/dev/)
[![Build status](https://github.com/JuliaGraphs/Metagraphs.jl/actions/workflows/ci.yml/badge.svg?branch=master)](https://github.com/JuliaGraphs/Metagraphs.jl/actions/workflows/ci.yml?query=branch%3Amaster)
[![Codecov](http://codecov.io/github/JuliaGraphs/Metagraphs.jl/coverage.svg?branch=master)](http://codecov.io/github/JuliaGraphs/Metagraphs.jl?branch=master)

A flexible package for graphs with arbitrary metadata.

> For a more performant option, check out [MetaGraphsNext.jl](https://github.com/JuliaGraphs/MetaGraphsNext.jl)

## Getting started

Installation is straightforward: from the Julia `pkg` prompt,
```julia
pkg> add MetaGraphs
```

Full documentation is available [here](https://juliagraphs.org/MetaGraphs.jl/).
Documentation for methods is also available via the Julia REPL help system.

## Example use

```julia
julia> using Graphs, MetaGraphs

# create a standard simplegraph
julia> g = path_graph(5)
{5, 4} undirected simple Int64 graph

# create a metagraph based on the simplegraph, with optional default edgeweight
julia> mg = MetaGraph(g, 3.0)
{5, 4} undirected Int64 metagraph with Float64 weights defined by :weight (default weight 3.0)

# create a directed metagraph based on the simplegraph, with optional default edgeweight
julia> mdg = MetaDiGraph(g, 3.0)
{5, 8} directed Int64 metagraph with Float64 weights defined by :weight (default weight 3.0)

# set some properties for the graph itself
julia> set_prop!(mg, :description, "This is a metagraph.")
Dict{Symbol,Any} with 1 entry:
  :description => "This is a metagraph."

# set properties on a vertex in bulk
julia> set_props!(mg, 1, Dict(:name=>"Susan", :id => 123))
true

# set individual properties
julia> set_prop!(mg, 2, :name, "John")
true

# set a property on an edge
julia> set_prop!(mg, Edge(1, 2), :action, "knows")
true

julia> using Dates: Date

# set another property on an edge by specifying source and destination
julia> set_prop!(mg, 1, 2, :since, Date("20170501", "yyyymmdd"))
Dict{Symbol,Any} with 2 entries:
  :since   => 2017-05-01
  :action => "knows"

# get all the properties for an element
julia> props(mg, 1)
Dict{Symbol,Any} with 2 entries:
  :id   => 123
  :name => "Susan"

# get a specific property by name
julia> get_prop(mg, 2, :name)
"John"

# set a default value to return in case the property does not exist
julia> get_prop(mg, 2, :nonexistent_prop, "default value")
"default value"

# delete a specific property
julia> rem_prop!(mg, 1, :name)
Dict{Symbol,Any} with 1 entry:
  :id => 123

# clear all properties for vertex 2
julia> clear_props!(mg, 2)
Dict{Symbol,Any} with 0 entries

# confirm there are no properties set for vertex 2
julia> props(mg, 2)
Dict{Symbol,Any} with 0 entries

# all Graphs.jl analytics work
julia> betweenness_centrality(mg)
5-element Array{Float64,1}:
 0.0
 0.5
 0.666667
 0.5
 0.0

# using weights
julia> mg = MetaGraph(complete_graph(3))
{3, 3} undirected Int64 metagraph with Float64 weights defined by :weight (default weight 1.0)

julia> enumerate_paths(dijkstra_shortest_paths(mg, 1), 3)
2-element Array{Int64,1}:
 1
 3

julia> set_prop!(mg, 1, 2, :weight, 0.2)
true

julia> set_prop!(mg, 2, 3, :weight, 0.6)
true

julia> enumerate_paths(dijkstra_shortest_paths(mg, 1), 3)
3-element Array{Int64,1}:
 1
 2
 3

# use vertex values as indices
julia> G = MetaGraph(100)
{100, 0} undirected Int64 metagraph with Float64 weights defined by :weight (default weight 1.0)

julia> for i in 1:100
           set_prop!(G, i, :name, "node$i")
       end

julia> set_indexing_prop!(G, :name)
Set(Symbol[:name])

# nodes can now be found by the value in the index
julia> G["node4", :name]
4

# You can also find the value of an index by the vertex number (note, this behavior will dominate if index values are also integers)
julia> G[4, :name]
"node4"

julia> set_prop!(G, 3, :name, "name3") # or set_indexing_prop!(G, 3, :name, "name3")
Set(Symbol[:name])
```

using MetaGraphs
using Test
using Graphs

property_set=[
    (src="thirty",dst="inf",color="missing",penwidth="missing",style="missing",label=""),
    (src="twenty",dst="mort",color="missing",penwidth="missing",style="missing",label="",),
    (src="rate",dst="personper",color="missing",penwidth="missing",style="missing",label="",),
    (src="person",dst="unit",color="missing",penwidth="missing",style="missing",label="",),
    (src="personper",dst="unit",color="missing",penwidth="missing",style="missing",label="",),
    (src="second",dst="unit",color="missing",penwidth="missing",style="missing",label="",),
    (src="dollars",dst="unit",color="missing",penwidth="missing",style="missing",label="",),
    (src="dGDP",dst="prices",color="missing",penwidth="missing",style="missing",label="",),
    (src="prices",dst="regres",color="missing",penwidth="missing",style="missing",label="",),
    (src="fed",dst="dGDP",color="missing",penwidth="missing",style="missing",label="",),
    (src="ode",dst="epi",color="missing",penwidth="missing",style="missing",label="",),
    (src="dollars",dst="cost",color="missing",penwidth="missing",style="missing",label="",),
    (src="mort",dst="rate",color="black",penwidth="2.0",style="dashed",label="",),
    (src="inf",dst="rate",color="black",penwidth="2.0",style="dashed",label="",),
    (src="birth",dst="rate",color="black",penwidth="2.0",style="dashed",label="",),
    (src="mort",dst="ind",color="orange",penwidth="4.0",style="solid",label="cause",),
    (src="ind",dst="epi",color="orange",penwidth="4.0",style="solid",label="two words",),
    (src="ind",dst="epi",color="orange",penwidth="4.0",style="solid",label="",),
    (src="inf",dst="ind",color="orange",penwidth="4.0",style="solid",label="one, other",),
    (src="birth",dst="ind",color="orange",penwidth="4.0",style="solid",label="one, other, and third one",),
    (src="temp",dst="inf",color="orange",penwidth="4.0",style="solid",label="",),
    (src="age",dst="mort",color="orange",penwidth="4.0",style="solid",label="",),
    (src="demo",dst="birth",color="orange",penwidth="4.0",style="solid",label="",),
    (src="epi",dst="cases",color="orange",penwidth="4.0",style="solid",label="",),
    (src="cases",dst="regres",color="orange",penwidth="4.0",style="solid",label="with single \" here",),
    (src="weather",dst="temp",color="orange",penwidth="4.0",style="solid",label="",),
    (src="demo",dst="age",color="orange",penwidth="4.0",style="solid",label="",),
    (src="regres",dst="cost",color="orange",penwidth="4.0",style="solid",label="with \"quoted\" word",),
    (src="html",dst="fed",color="black",penwidth="2.0",style="solid",label="",)
]

# name, label, color
vprops = [
    ("weather","NOAA\\nWeather","orange"),
    ("cost","Vaccination\\nCost","orange"),
    ("demo","Census\\nDemographics","orange"),
    ("fed", "Fed Forcast", "#5DADE2"),
    ("epi","SIR","#5DADE2"),
    ("ode", "ODE Solver", "#5DADE2"),
    ("rate","{Transition\\nRate}","#66AA55"),
    ("unit","Unit","#66AA55"),
    ("personper","Person/s","#66AA55"),
    ("person","Person","#66AA55"),
    ("second","second (s)","#66AA55"),
    ("dollars","\$","#66AA55"),
    ("inf","Infection\\nRate","#66AA55"),
    ("mort","Mortality\\nRate","#66AA55"),
    ("birth","Birth\\nRate","#66AA55"),
    ("twenty","0.2 Persons/s","#DD1133"),
    ("thirty","0.3 Persons/s","#DD1133"),
    ("ind","Individual\\n\"Contact\"\\nModel","#5DADE2"),
    ("temp","Temperature","#5DADE2"),
    ("age","Age","#5DADE2"),
    ("dGDP","Economic Growth","#5DADE2"),
    ("cases","Flu\\nCases","#5DADE2"),
    ("prices","Vacc\\nPrice","#5DADE2"),
    ("regres", "Regression", "#5DADE2"),
    ("html", "<<U><B>Title </B></U> <BR/> Some text.>", "#000000"),
]

g = MetaDiGraph(25)

set_prop!(g, :pack, true)

for (v, prop) in enumerate(vprops)
    set_prop!(g, v, :name,  prop[1])
    set_prop!(g, v, :label, prop[2])
    set_prop!(g, v, :color, prop[3])
end

# enable indexing with string names
set_indexing_prop!(g, :name)

# add edges
for prop in property_set
    src, dst = g[prop.src, :name], g[prop.dst, :name]
    add_edge!(g, src, dst)
    set_prop!(g, src, dst, :color, prop.color)
    set_prop!(g, src, dst, :penwidth, prop.penwidth)
    set_prop!(g, src, dst, :style, prop.style)
    set_prop!(g, src, dst, :label, prop.label)
end

# set global edge properties
for e in edges(g)
    set_prop!(g, e, :dir, :none)
end
# set global vertex properties
for v in vertices(g)
    set_prop!(g, v, :shape, :record)
    set_prop!(g, v, :style, :filled)
    set_prop!(g, v, :fillcolor, "#dddddd")
    set_prop!(g, v, :penwidth, 2.0)
end

@testset "dotio" begin
    savegraph("diagram.dot", g, DOTFormat())
    open("diagram_ref.dot") do fp
        s_ref = read(fp)
        open("diagram.dot") do fp
            s = read(fp)
            @test s == s_ref
        end

    # Verify that HTML labels are saved without quotes, but that "conventional" (non-html) labels are saved with quotes.
    # The label attribute should be either delimited by:
    #   - "..."     : OK
    #   - <...>     : OK
    #   - both      : NOK ("< or >" as bounding characters, resulting HTML in file will not be parsed correctly by dot.)
    quote_regex = r"label\s*=\s*\"(?:[^\"\\]|\\.)*\"" # source: https://stackoverflow.com/questions/249791/regex-for-quoted-string-with-escaping-quotes
    html_regex = r"label\s*=\s*<.*>"
    invalid_quote_regex = r"label\s*=\s*\"<(?:[^\"\\]|\\.)*>\""
    for line in eachline(fp)
            test_val = false
            if  !occursin(r"label\s*=",line)
                # the line does not contain a "label" attribute
                test_val = true
            elseif occursin(quote_regex, line)
                # check if a "< or >" combination is present as outer delimiter, this shouldn't occur.
                test_val =  !occursin(invalid_quote_regex, line)
            elseif occursin(html_regex, line)
                # no worries, proper HTML surrounding brackets found.
                test_val = true
            end
        @test test_val
    end
end


end

using Documenter, MetaGraphs

# index is equal to the README for the time being
cp(normpath(@__FILE__, "../../README.md"), normpath(@__FILE__, "../src/index.md"); force=true)

# same for license
cp(normpath(@__FILE__, "../../LICENSE.md"), normpath(@__FILE__, "../src/license.md"); force=true)

makedocs(
    modules = [MetaGraphs],
    sitename = "MetaGraphs",
    format = Documenter.HTML(prettyurls=get(ENV, "CI", nothing) == "true"),
    pages = Any[
        "Overview"             => "index.md",
        "MetaGraphs Functions" => "metagraphs.md",
        "License Information"  => "license.md",
    ],
)

deploydocs(repo="github.com/JuliaGraphs/MetaGraphs.jl.git", push_preview=true)

rm(normpath(@__FILE__, "../src/index.md"))
rm(normpath(@__FILE__, "../src/license.md"))

using MetaGraphs
import Graphs: SimpleGraphs
import Base64:
    stringmime


@testset "MetaGraphs" begin

    # constructors
    @test @inferred(MetaGraph()) == MetaGraph(SimpleGraph())
    @test @inferred(MetaDiGraph()) == MetaDiGraph(SimpleDiGraph())

    @test !is_directed(MetaGraph)
    @test is_directed(MetaDiGraph)

    adjmx1 = [0 1 0; 1 0 1; 0 1 0] # SimpleGraph
    adjmx2 = [0 1 0; 1 0 1; 1 1 0] # SimpleDiGraph
    gx = path_graph(4)
    dgx = path_digraph(4)

    mg = MetaGraph()
    @test add_vertex!(mg, :color, "red") && get_prop(mg, nv(mg), :color) == "red"
    @test add_vertex!(mg, Dict(:color => "red", :prop2 => "prop2")) && props(mg, nv(mg)) == Dict(:color => "red", :prop2 => "prop2")
    @test add_edge!(mg, 1, 2, :color, "blue") && get_prop(mg, 1, 2, :color) == "blue"
    @test add_vertex!(mg) && add_edge!(mg, 1, 3, Dict(:color => "red", :prop2 => "prop2")) && props(mg, 1, 3) == Dict(:color => "red", :prop2 => "prop2")

    for g in testgraphs(gx)
        mg = MetaGraph(g)
        g2 = SimpleGraph(mg)
        @test g2 == mg.graph

        @test eltype(@inferred(MetaGraph{UInt8,Float16}(mg))) == UInt8
        @test weighttype(@inferred(MetaGraph{UInt8,Float16}(mg))) == Float16

        @test @inferred(MetaGraphs.fadj(mg, 2)) == Graphs.SimpleGraphs.fadj(g, 2)
        @test @inferred(MetaGraphs.badj(mg, 2)) == Graphs.SimpleGraphs.badj(g, 2)

        @test @inferred(edgetype(mg)) == edgetype(mg.graph)

        @test @inferred(eltype(mg)) == eltype(g)
        @test @inferred(eltype(MetaGraph(g, 2.0))) == eltype(g)
        @test @inferred(eltype(MetaGraph(g, :cost))) == eltype(g)
        @test @inferred(eltype(MetaGraph(g, :cost, 2.0))) == eltype(g)
        @test @inferred(eltype(MetaGraph{UInt8,Float16}(g))) == UInt8
        @test @inferred(eltype(MetaGraph{UInt8,Float16}(g, :cost))) == UInt8
        @test @inferred(eltype(MetaGraph{UInt8,Float16}(g, 4))) == UInt8
        @test @inferred(ne(mg)) == 3
        @test @inferred(nv(mg)) == 4
        @test @inferred(!is_directed(mg))

        @test @inferred(vertices(mg)) == 1:4
        @test Edge(2, 3) in edges(mg)
        @test @inferred(outneighbors(mg, 2)) == inneighbors(mg, 2) == neighbors(mg, 2)
        @test @inferred(has_edge(mg, 2, 3))
        @test @inferred(has_edge(mg, 3, 2))

        mgc = copy(mg)
        @test @inferred(add_edge!(mgc, 4 => 1)) && mgc == MetaGraph(cycle_graph(4))
        @test @inferred(has_edge(mgc, 4 => 1)) && has_edge(mgc, 0x04 => 0x01)
        mgc = copy(mg)
        @test @inferred(add_edge!(mgc, (4, 1))) && mgc == MetaGraph(cycle_graph(4))
        @test @inferred(has_edge(mgc, (4, 1))) && has_edge(mgc, (0x04, 0x01))
        mgc = copy(mg)
        @test add_edge!(mgc, 4, 1) && mgc == MetaGraph(cycle_graph(4))

        @test @inferred(add_vertex!(mgc))   # out of order, but we want it for issubset
        @test @inferred(mg ⊆ mgc)
        @test @inferred(has_vertex(mgc, 5))
        @test @inferred(rem_edge!(mgc, 1, 2)) && @inferred(!has_edge(mgc, 1, 2))

        mga = @inferred(copy(mg))
        @test @inferred(rem_vertex!(mga, 2)) && ne(mga) == 1
        @test @inferred(!rem_vertex!(mga, 10))

        @test @inferred(zero(mg)) == MetaGraph{eltype(mg),weighttype(mg)}()
        @test @inferred(eltype(mg)) == eltype(outneighbors(mg, 1)) == eltype(nv(mg))
        T = @inferred(eltype(mg))
        U = @inferred(weighttype(mg))
        @test @inferred(nv(MetaGraph{T,U}(6))) == 6

        # get_prop with default argument
        # vertices
        set_prop!(mg, nv(mg), :testprop, "exists")
        @test get_prop(mg, nv(mg), :testprop, "nonexistent") == "exists"
        @test get_prop(mg, nv(mg), :testprop_nonexist, "nonexistent") == "nonexistent"
        @test get_prop(mg, nv(mg) + 100, :testprop_nonexist, "nonexistent") == "nonexistent"

        # edges
        set_prop!(mg, 1, 2, :testedgeprop, "5 meters")
        @test get_prop(mg, 1, 2, :testedgeprop, "0 meters") == "5 meters"
        @test get_prop(mg, 1, 2, :testedgeprop_nonexist, "0 meters") == "0 meters"
        @test get_prop(mg, 2, 4, :testedgeprop_nonexist, "0 meters") == "0 meters"
        @test get_prop(mg, 2, 1, :testedgeprop, "0 meters") == "5 meters"
        @test get_prop(mg, 2, 1, :testedgeprop_nonexist, "0 meters") == "0 meters"

        @test get_prop(mg, Edge(1, 2), :testedgeprop, "0 meters") == "5 meters"
        @test get_prop(mg, Edge(1, 2), :testedgeprop_nonexist, "0 meters") == "0 meters"
        @test get_prop(mg, Edge(2, 4), :testedgeprop_nonexist, "0 meters") == "0 meters"
        @test get_prop(mg, Edge(2, 1), :testedgeprop, "0 meters") == "5 meters"
        @test get_prop(mg, Edge(2, 1), :testedgeprop_nonexist, "0 meters") == "0 meters"

        # graph
        set_prop!(mg, :testgraphpprop, "linegraph")
        @test get_prop(mg, :testgraphpprop, "circlegraph") == "linegraph"
        @test get_prop(mg, :testgraphpprop_nonexist, "circlegraph") == "circlegraph"
    end

    for g in testdigraphs(dgx)
        mg = MetaDiGraph(g)
        g2 = SimpleDiGraph(mg)
        @test g2 == mg.graph

        @test eltype(@inferred(MetaDiGraph{UInt8,Float16}(mg))) == UInt8
        @test weighttype(@inferred(MetaDiGraph{UInt8,Float16}(mg))) == Float16

        @test @inferred(MetaGraphs.fadj(mg, 2)) == Graphs.SimpleGraphs.fadj(g, 2)
        @test @inferred(MetaGraphs.badj(mg, 2)) == Graphs.SimpleGraphs.badj(g, 2)

        @test @inferred(edgetype(mg)) == edgetype(mg.graph)

        @test @inferred(eltype(mg)) == eltype(g)
        @test @inferred(eltype(MetaDiGraph(g, 2.0))) == eltype(g)
        @test @inferred(eltype(MetaDiGraph(g, :cost))) == eltype(g)
        @test @inferred(eltype(MetaDiGraph(g, :cost, 2.0))) == eltype(g)
        @test @inferred(eltype(MetaDiGraph{UInt8,Float16}(g))) == UInt8
        @test @inferred(eltype(MetaDiGraph{UInt8,Float16}(g, :cost))) == UInt8
        @test @inferred(eltype(MetaDiGraph{UInt8,Float16}(g, 4))) == UInt8

        @test @inferred(ne(mg)) == 3
        @test @inferred(nv(mg)) == 4
        @test @inferred(is_directed(mg))

        @test @inferred(vertices(mg)) == 1:4
        @test Edge(2, 3) in edges(mg)
        @test @inferred(outneighbors(mg, 2)) == [3]
        @test @inferred(inneighbors(mg, 2)) == [1]
        @test @inferred(has_edge(mg, 2, 3))
        @test @inferred(!has_edge(mg, 3, 2))

        mgc = copy(mg)
        @test @inferred(add_edge!(mgc, 4 => 1)) && mgc == MetaDiGraph(cycle_digraph(4))
        @test @inferred(has_edge(mgc, 4 => 1)) && has_edge(mgc, 0x04 => 0x01)
        mgc = copy(mg)
        @test @inferred(add_edge!(mgc, (4, 1))) && mgc == MetaDiGraph(cycle_digraph(4))
        @test @inferred(has_edge(mgc, (4, 1))) && has_edge(mgc, (0x04, 0x01))
        mgc = copy(mg)
        @test add_edge!(mgc, 4, 1) && mgc == MetaDiGraph(cycle_digraph(4))

        @test @inferred(add_vertex!(mgc))   # out of order, but we want it for issubset
        @test @inferred(mg ⊆ mgc)
        @test @inferred(has_vertex(mgc, 5))
        @test @inferred(rem_edge!(mgc, 1, 2)) && @inferred(!has_edge(mgc, 1, 2))

        mga = @inferred(copy(mg))
        @test @inferred(rem_vertex!(mga, 2)) && ne(mga) == 1
        @test @inferred(!rem_vertex!(mga, 10))

        @test @inferred(zero(mg)) == MetaDiGraph{eltype(mg),weighttype(mg)}()
        @test @inferred(eltype(mg)) == eltype(outneighbors(mg, 1)) == eltype(nv(mg))
        T = @inferred(eltype(mg))
        U = @inferred(weighttype(mg))
        @test @inferred(nv(MetaDiGraph{T,U}(6))) == 6

        # get_prop with default argument
        # vertices
        set_prop!(mg, nv(mg), :testprop, "exists")
        @test get_prop(mg, nv(mg), :testprop, "nonexistent") == "exists"
        @test get_prop(mg, nv(mg), :testprop_nonexist, "nonexistent") == "nonexistent"
        @test get_prop(mg, nv(mg) + 100, :testprop_nonexist, "nonexistent") == "nonexistent"

        # edges
        set_prop!(mg, 1, 2, :testedgeprop, "5 meters")
        @test get_prop(mg, 1, 2, :testedgeprop, "0 meters") == "5 meters"
        @test get_prop(mg, 1, 2, :testedgeprop_nonexist, "0 meters") == "0 meters"
        @test get_prop(mg, 2, 4, :testedgeprop_nonexist, "0 meters") == "0 meters"
        @test get_prop(mg, 2, 1, :testedgeprop, "0 meters") == "0 meters"
        @test get_prop(mg, 2, 1, :testedgeprop_nonexist, "0 meters") == "0 meters"

        @test get_prop(mg, Edge(1, 2), :testedgeprop, "0 meters") == "5 meters"
        @test get_prop(mg, Edge(1, 2), :testedgeprop_nonexist, "0 meters") == "0 meters"
        @test get_prop(mg, Edge(2, 4), :testedgeprop_nonexist, "0 meters") == "0 meters"
        @test get_prop(mg, Edge(2, 1), :testedgeprop, "0 meters") == "0 meters"
        @test get_prop(mg, Edge(2, 1), :testedgeprop_nonexist, "0 meters") == "0 meters"

        # graph
        set_prop!(mg, :testgraphpprop, "linegraph")
        @test get_prop(mg, :testgraphpprop, "circlegraph") == "linegraph"
        @test get_prop(mg, :testgraphpprop_nonexist, "circlegraph") == "circlegraph"
    end

    for gbig in [SimpleGraph(0xff), SimpleDiGraph(0xff)]
        mg = MetaGraph(gbig)
        @test @inferred(!add_vertex!(mg))    # overflow
        @test @inferred(add_vertices!(mg, 10)) < 10
    end

    gx = SimpleGraph()
    for g in testgraphs(gx)
        mg = MetaGraph(g)
        T = eltype(mg)
        U = weighttype(mg)
        @test sprint(show, mg) == "{0, 0} undirected $T metagraph with $U weights defined by :$(mg.weightfield) (default weight $(mg.defaultweight))"
        @test @inferred(add_vertices!(mg, 5)) == 5
        @test sprint(show, mg) == "{5, 0} undirected $T metagraph with $U weights defined by :$(mg.weightfield) (default weight $(mg.defaultweight))"
    end
    gx = SimpleDiGraph()
    for g in testdigraphs(gx)
        mg = MetaDiGraph(g)
        T = eltype(mg)
        U = weighttype(mg)
        @test sprint(show, mg) == "{0, 0} directed $T metagraph with $U weights defined by :$(mg.weightfield) (default weight $(mg.defaultweight))"
        @test @inferred(add_vertices!(mg, 5)) == 5
        @test sprint(show, mg) == "{5, 0} directed $T metagraph with $U weights defined by :$(mg.weightfield) (default weight $(mg.defaultweight))"
    end

    mg = MetaGraph(complete_graph(3), 3.0)
    @test enumerate_paths(dijkstra_shortest_paths(mg, 1), 3) == [1, 3]
    @test set_prop!(mg, 1, 2, :weight, 0.2)
    @test !set_prop!(mg, 1000, 2, :weight, 0.2) # nonexistent edge
    @test set_prop!(mg, 2, 3, :weight, 1)
    @test enumerate_paths(dijkstra_shortest_paths(mg, 1), 3) == [1, 2, 3]

    # issue #60
    mg60 = MetaGraph(2)
    add_edge!(mg60, 1, 2)
    set_prop!(mg60, 2, 1, :weight, 7.0)
    @test get_prop(mg60, 1, 2, :weight) == 7.0
    @test get_prop(mg60, 2, 1, :weight) == 7.0
    @test weights(mg60)[1, 2] == 7.0
    @test weights(mg60)[2, 1] == 7.0
    mdg60 = MetaDiGraph(2)
    add_edge!(mdg60, 1, 2)
    add_edge!(mdg60, 2, 1)
    set_prop!(mdg60, 2, 1, :weight, 7.0)
    @test get_prop(mdg60, 2, 1, :weight) == 7.0
    @test weights(mdg60)[1, 2] == 1.0
    @test weights(mdg60)[2, 1] == 7.0

    @test set_prop!(mg, 1, :color, "blue")
    @test set_prop!(mg, 1, :color, "blue")
    @test !set_prop!(mg, 1000, :color, "blue") # nonexistent vertex
    @test set_prop!(mg, 1, :id, 0x5)
    @test set_prop!(mg, 1, :id, 0x5)
    @test set_prop!(mg, :name, "test graph")
    @test set_prop!(mg, :name, "test graph")


    @test length(props(mg)) == 1
    @test length(props(mg, 1)) == 2
    @test length(props(mg, 1, 2)) == 1

    @test get_prop(mg, :name) == "test graph"
    @test get_prop(mg, 1, :color) == "blue"
    @test get_prop(mg, 1, 2, :weight) == 0.2

    set_prop!(mg, :del, 0x2)
    set_prop!(mg, 1, :del, 0x2)
    set_prop!(mg, 1, 2, :del, 0x2)

    rem_prop!(mg, :del)
    rem_prop!(mg, 1, :del)
    rem_prop!(mg, 1, 2, :del)
    @test_throws KeyError get_prop(mg, 1, :del)
    @test get_prop(mg, 1, :id) == 0x5
    clear_props!(mg)
    @test length(props(mg)) == 0
    clear_props!(mg, 1)
    @test length(props(mg, 1)) == 0
    clear_props!(mg, 1, 2)
    @test length(props(mg, 1, 2)) == 0

    # metagraph constructor from metadigraph
    mdg = MetaDiGraph(path_digraph(4), 3.0)
    set_prop!(mdg, 1, 2, :name, 12)
    set_prop!(mdg, 2, 3, :name, 23)
    set_prop!(mdg, 3, 4, :name, 34)
    set_indexing_prop!(mdg, 1, :foo, "v1")
    set_indexing_prop!(mdg, 2, :foo, "v2")
    set_indexing_prop!(mdg, 3, :foo, "v3")
    set_indexing_prop!(mdg, 4, :foo, "v4")

    dg = MetaGraph(mdg)
    set_prop!(mdg, 1, 2, :name, 99)
    @test get_prop(mdg, 1, 2, :name) == 99
    @test get_prop(dg, 1, 2, :name) == 12

    set_indexing_prop!(mdg, 1, :foo, "99")
    @test get_prop(mdg, 1, :foo) == "99"
    @test get_prop(dg, 1, :foo) == "v1"
    add_vertex!(mdg)
    @test nv(mdg) == nv(dg) + 1
    add_edge!(mdg, 1, 3)
    @test !has_edge(dg, 1, 3)
    defaultweight!(mdg, 11.11)
    @test defaultweight(dg) == 3.0

    mg = MetaDiGraph(path_digraph(3), 3.0)
    add_edge!(mg, 1, 3)
    @test enumerate_paths(dijkstra_shortest_paths(mg, 1), 3) == [1, 3]
    @test set_prop!(mg, 1, 2, :weight, 0.2)
    @test !set_prop!(mg, 1000, 2, :weight, 0.2) # nonexistent edge
    @test set_prop!(mg, 2, 3, :weight, 1)
    @test enumerate_paths(dijkstra_shortest_paths(mg, 1), 3) == [1, 2, 3]

    @test set_prop!(mg, 1, :color, "blue")
    @test !set_prop!(mg, 1000, :color, "blue") # nonexistent vertex
    @test set_prop!(mg, 1, :id, 0x5)
    @test set_prop!(mg, :name, "test graph")


    @test length(props(mg)) == 1
    @test length(props(mg, 1)) == 2
    @test length(props(mg, 1, 2)) == 1

    @test get_prop(mg, :name) == "test graph"
    @test get_prop(mg, 1, :color) == "blue"
    @test get_prop(mg, 1, 2, :weight) == 0.2

    set_prop!(mg, :del, 0x2)
    set_prop!(mg, 1, :del, 0x2)
    set_prop!(mg, 1, 2, :del, 0x2)

    @test has_prop(mg, :del)
    @test has_prop(mg, 1, :del)
    @test has_prop(mg, 1, 2, :del)
    rem_prop!(mg, :del)
    rem_prop!(mg, 1, :del)
    rem_prop!(mg, 1, 2, :del)
    @test !has_prop(mg, :del)
    @test !has_prop(mg, 1, :del)
    @test !has_prop(mg, 1, 2, :del)
    @test_throws KeyError get_prop(mg, 1, :del)
    @test get_prop(mg, 1, :id) == 0x5
    clear_props!(mg)
    @test length(props(mg)) == 0
    clear_props!(mg, 1)
    @test length(props(mg, 1)) == 0
    clear_props!(mg, 1, 2)
    @test length(props(mg, 1, 2)) == 0

    mg = MetaGraph(complete_graph(3), 3.0)
    mw = MetaGraphs.MetaWeights(mg)
    @test mw[1, 2] == 3.0
    @test sprint(show, mw) == stringmime("text/plain", mw) == "metaweights"
    @test size(mw) == (3, 3)
    set_prop!(mg, 1, 2, :weight, 0.2)
    set_prop!(mg, 2, 3, :weight, 1)
    @test weightfield!(mg, :cost) == :cost
    @test enumerate_paths(dijkstra_shortest_paths(mg, 1), 3) == [1, 3]
    @test weightfield!(mg, :weight) == :weight
    @test enumerate_paths(dijkstra_shortest_paths(mg, 1), 3) == [1, 2, 3]

    @test set_props!(mg, 1, 2, Dict(:color => :blue, :action => "knows"))
    @test length(props(mg, 1, 2)) == 3
    @test rem_edge!(mg, 1, 2)
    @test length(props(mg, 1, 2)) == 0
    @test set_props!(mg, Dict(:name => "testgraph", :type => "undirected"))
    @test length(props(mg)) == 2

    mg = MetaGraph(complete_graph(3), 3.0)
    set_prop!(mg, 1, :color, "blue")
    set_prop!(mg, 1, :id, 40)
    set_prop!(mg, 2, :color, "red")
    set_prop!(mg, 2, :id, 80)
    set_prop!(mg, 3, :color, "blue")
    set_prop!(mg, 1, 2, :weight, 0.2)
    set_prop!(mg, 2, 3, :weight, 0.6)
    set_prop!(mg, :name, "test metagraph")

    @test length(collect(filter_edges(mg, :weight))) == 2
    @test length(collect(filter_edges(mg, :weight, 0.2))) == 1
    @test length(collect(filter_vertices(mg, :color))) == 3
    @test length(collect(filter_vertices(mg, :color, "blue"))) == 2

    fv1 = filter_vertices(mg, :id)
    fv2 = filter_vertices(mg, :color, "blue")
    fe1 = filter_edges(mg, :weight)
    fe2 = filter_edges(mg, :weight, 0.6)

    i = mg[fv1]
    @test nv(i) == 2 && ne(i) == 1
    @test has_prop(i, 1, :id)
    @test has_prop(i, 2, :id)

    i = mg[fv2]
    @test nv(i) == 2 && ne(i) == 1
    @test get_prop(i, 1, :color) == "blue"
    @test get_prop(i, 2, :color) == "blue"

    i = mg[fe1]
    @test nv(i) == 3 && ne(i) == 2
    @test sum(get_prop(i, e, :weight) for e in edges(i)) == 0.8

    i = mg[fe2]
    @test nv(i) == 2 && ne(i) == 1
    @test get_prop(i, 1, :color) == "red"
    @test get_prop(i, 2, :color) == "blue"
    @test get_prop(i, 1, 2, :weight) == 0.6


    # test for #15
    mga = MetaGraph(Graph(5))
    for v in vertices(mga)
        set_prop!(mga, v, :name, string(v))
    end
    set_indexing_prop!(mga, :name)
    @test get_prop(mga, 1, :name) == "1"
    @test get_prop(mga, 5, :name) == "5"
    @test rem_vertex!(mga, 1)
    @test get_prop(mga, 1, :name) == "5"
    @test mga["5", :name] == 1
    @test isempty(props(mga, 5))

    # test for #22
    mga = MetaGraph(path_graph(4))
    set_prop!(mga, 1, 2, :name, "1, 2")
    set_prop!(mga, 2, 3, :name, "2, 3")
    set_prop!(mga, 3, 4, :name, "3, 4")
    @test rem_vertex!(mga, 2)
    @test nv(mga) == 3
    @test ne(mga) == 1
    @test length(mga.eprops) == 1  # should only be edge 2=>3
    @test props(mga, 2, 3)[:name] == "3, 4"

    # test for #72 - Multiple indicies that are not all used
    let
        test_graph = x -> begin
            g = MetaGraph()
            set_indexing_prop!(g, :IndexA)
            set_indexing_prop!(g, :IndexB)
            add_vertex!(g, :IndexA, "A")
            x && add_vertex!(g, :IndexA, "B")
            x && set_indexing_prop!(g, nv(g), :IndexB, "B")
            add_vertex!(g, :IndexB, "C")
            g
        end
        mga = test_graph(true)
        rem_vertex!(mga, 2)
        @test mga == test_graph(false)
    end

    mga = MetaDiGraph(path_digraph(4))
    set_prop!(mga, 1, 2, :name, "1, 2")
    set_prop!(mga, 2, 3, :name, "2, 3")
    set_prop!(mga, 3, 4, :name, "3, 4")
    @test rem_vertex!(mga, 2)
    @test nv(mga) == 3
    @test ne(mga) == 1
    @test length(mga.eprops) == 1 # should only be edge 3=>2
    @test props(mga, 3, 2)[:name] == "3, 4"

    # test for #32
    mga = MetaGraph(path_graph(4))
    for j in 1:4
        set_prop!(mga, j, :prop, "node$j")
    end
    set_indexing_prop!(mga, :prop)
    add_vertex!(mga)
    set_indexing_prop!(mga, nv(mga), :prop, "node5")
    @test mga["node5", :prop] == 5
    @test get_prop(mga, 5, :prop) == "node5"

    # test for #33
    mga = MetaGraph(path_graph(4))
    set_prop!(mga, 1, 2, :name, "1, 2")
    set_prop!(mga, 2, 3, :name, "2, 3")
    set_prop!(mga, 3, 4, :name, "3, 4")
    set_prop!(mga, 3, :v, 3)
    set_prop!(mga, 4, :v, 4)
    @test rem_vertex!(mga, nv(mga))
    @test has_prop(mga, 2, 3, :name)
    @test !has_prop(mga, 3, 4, :name)
    @test !has_prop(mga, 4, :v)
    @test has_prop(mga, 3, :v)

    # test for setting indexed props with set_prop!
    mga = MetaGraph(path_graph(4))
    for j in 1:3
        set_indexing_prop!(mga, j, :prop, "node$j")
    end
    add_vertex!(mga)
    set_prop!(mga, nv(mga), :prop, "node5")
    set_prop!(mga, 1, :prop, "newnode1")
    @test get_prop(mga, 4, :prop) == "prop4"
    @test mga["node5", :prop] == 5
    @test get_prop(mga, 5, :prop) == "node5"
    @test get_prop(mga, 1, :prop) == "newnode1"

    # test for 87
    mdg = MetaDiGraph(2)
    add_edge!(mdg, 2, 2)
    rem_vertex!(mdg, 1)
    @test neighbors(mdg, 1) == [1]
    @test nv(mdg) == 1

end

@testset "MetaIndexing" begin
    G = MetaGraph(100)
    dG = MetaDiGraph(100)

    for i in 1:100
        set_prop!(G, i, :name, "gnode_$i")
        set_prop!(dG, i, :name, "dgnode_$i")
    end

    for i in 1:100
        set_prop!(G, i, :not_unique, "$(i % 5)")
        set_prop!(dG, i, :not_unique, "$(i % 5)")
    end

    @test set_indexing_prop!(G, :name) == Set{Symbol}([:name])
    @test set_indexing_prop!(dG, :name) == Set{Symbol}([:name])
    @test_throws ErrorException set_indexing_prop!(G, :not_unique)
    @test_throws ErrorException set_indexing_prop!(dG, :not_unique)

    @test G["gnode_3", :name] == 3
    @test dG["dgnode_99", :name] == 99

    @test_throws ErrorException set_indexing_prop!(G, 4, :name, "gnode_3")
    @test_throws ErrorException set_indexing_prop!(dG, 4, :name, "dgnode_3")
    @test_throws ErrorException set_prop!(G, 4, :name, "gnode_3")
    @test_throws ErrorException set_prop!(dG, 4, :name, "dgnode_3")

    @test MetaGraphs.index_available(G, 7, :name, "gnode_8") == false
    @test MetaGraphs.index_available(G, 7, :name, "gnode_7") == true
    @test MetaGraphs.index_available(G, 7, :another_prop, "gnode_8") == true
    @test MetaGraphs.index_available(G, 7, :name, "gnode_8-anothername") == true

    @test MetaGraphs.index_available(dG, 7, :name, "dgnode_8") == false
    @test MetaGraphs.index_available(dG, 7, :name, "dgnode_7") == true
    @test MetaGraphs.index_available(dG, 7, :another_prop, "dgnode_8") == true
    @test MetaGraphs.index_available(dG, 7, :name, "dgnode_8-anothername") == true

    @test_throws ErrorException set_props!(G, 11, Dict(:name => "gnode_3", :other_name => "something11"))
    @test_throws ErrorException set_props!(dG, 11, Dict(:name => "dgnode_3", :other_name => "something11"))
    @test_throws KeyError get_prop(G, 11, :other_name)
    @test_throws KeyError get_prop(dG, 11, :other_name)

    @test set_props!(G, 5, Dict(:name => "name5", :other_name => "something"))
    @test set_props!(dG, 5, Dict(:name => "dname5", :other_name => "something"))
    @test G["name5", :name] == 5
    @test dG["dname5", :name] == 5


    @info("Ignore \"'foo1' is already in index\" warnings")
    set_indexing_prop!(G, 50, :name, "another name")
    set_indexing_prop!(G, 50, :name, "another name")

    set_indexing_prop!(G, 43, :foo, "foo1")
    set_indexing_prop!(dG, 43, :foo, "foo1")
    @test G[1, :foo] != "foo1"
    @test dG[1, :foo] != "foo1"

    set_indexing_prop!(G, 42, :foo, "bar")
    set_indexing_prop!(dG, 42, :foo, "bar")

    @test G["foo10", :foo] == 10
    @test G[12, :foo] == "foo12"
    @test G["bar", :foo] == 42
    @test G[42, :foo] == "bar"
    @test isa(G[:foo], Dict{Any,Integer})
    @test isa(dG[:foo], Dict{Any,Integer})


    @test dG["foo30", :foo] == 30
    @test dG[79, :foo] == "foo79"
    @test dG["bar", :foo] == 42
    @test dG[42, :foo] == "bar"

    @test_throws ErrorException G[:not_a_key]
    @test_throws ErrorException dG[:not_a_key]
end

mutable struct MetaDiGraph{T<:Integer,U<:Real} <: AbstractMetaGraph{T}
    graph::SimpleDiGraph{T}
    vprops::Dict{T,PropDict}
    eprops::Dict{SimpleEdge{T},PropDict}
    gprops::PropDict
    weightfield::Symbol
    defaultweight::U
    metaindex::MetaDict
    indices::Set{Symbol}
end

function MetaDiGraph(x, weightfield::Symbol, defaultweight::U) where U <: Real
    T = eltype(x)
    g = SimpleDiGraph(x)
    vprops = Dict{T,PropDict}()
    eprops = Dict{SimpleEdge{T},PropDict}()
    gprops = PropDict()
    metaindex = MetaDict()
    idxs = Set{Symbol}()

    MetaDiGraph(g, vprops, eprops, gprops,
        weightfield, defaultweight,
        metaindex, idxs)
end

MetaDiGraph() = MetaDiGraph(SimpleDiGraph())
MetaDiGraph{T,U}() where T <: Integer where U <: Real = MetaDiGraph(SimpleDiGraph{T}(), one(U))
MetaDiGraph{T,U}(x::Integer) where T <: Integer where U <: Real = MetaDiGraph(T(x), :weight, U(1.0))
MetaDiGraph(x) = MetaDiGraph(x, :weight, 1.0)
MetaDiGraph(x, weightfield::Symbol) = MetaDiGraph(x, weightfield, 1.0)
MetaDiGraph(x, defaultweight::Real) = MetaDiGraph(x, :weight, defaultweight)

# converts MetaDiGraph{Int,Float64} to MetaDiGraph{UInt8, Float32}
function MetaDiGraph{T,U}(g::MetaDiGraph) where T<:Integer where U<:Real
    newg = SimpleDiGraph{T}(g.graph)
    return MetaDiGraph(newg, U(g.defaultweight))
end

function MetaDiGraph{T,U}(g::SimpleDiGraph, weightfield::Symbol=:weight, defaultweight::Real=1.0) where T<:Integer where U<:Real
    newg = SimpleDiGraph{T}(g)
    return MetaDiGraph(newg, weightfield, U(defaultweight))
end

function MetaDiGraph{T,U}(g::SimpleDiGraph, defaultweight::Real) where T<:Integer where U<:Real
    newg = SimpleDiGraph{T}(g)
    return MetaDiGraph(newg, :weight, U(defaultweight))
end


SimpleDiGraph(g::MetaDiGraph) = g.graph


is_directed(::Type{MetaDiGraph}) = true
is_directed(::Type{MetaDiGraph{T,U}}) where T where U = true
is_directed(g::MetaDiGraph) = true

weighttype(g::MetaDiGraph{T,U}) where T where U = U

props(g::MetaDiGraph, e::SimpleEdge) = get(PropDict, g.eprops, e)

function set_props!(g::MetaDiGraph, e::SimpleEdge, d::Dict)
    if has_edge(g, e)
        if !_hasdict(g, e)
            g.eprops[e] = d
        else
            merge!(g.eprops[e], d)
        end
        return true
    end
    return false
end

zero(g::MetaDiGraph{T,U}) where T where U = MetaDiGraph{T,U}(SimpleDiGraph{T}())

# Metagraphs files are simply JLD2 files.

struct MGFormat <: AbstractGraphFormat end
struct DOTFormat <: AbstractGraphFormat end

function loadmg(fn::AbstractString)
    @load fn g
    return g
end

function savemg(fn::AbstractString, g::AbstractMetaGraph)
    @save fn g
    return 1
end

loadgraph(fn::AbstractString, gname::String, ::MGFormat) = loadmg(fn)
savegraph(fn::AbstractString, g::AbstractMetaGraph) =  savemg(fn, g)

# escaping unescaped quotation marks
# i.e. replacing `"`` with `\"` while leaving `\"` as is
escape_quotes(s::AbstractString) = replace(s, r"([^\\])\"" => s"\1\\\\\"")

# According to the DOT language specification https://graphviz.org/doc/info/lang.html
# we can quote everyhthing that's not an XML/HTML literal
function quote_prop(p::AbstractString)
    if  occursin(r"<+.*>+$", p)
        # The label is an HTML string, no additional quotes here.
        return p
    else
        return "\"" * escape_quotes(p) * "\""
    end
end
# if the property value is _not_ a string it cannot be XML/HTML literal, so just put it in quotes
quote_prop(p::Any) = "\"" * escape_quotes(string(p)) * "\""
# NOTE: down there I only quote property _values_. DOT allows quoting property _names_ too
# I don't do that as long as names are Symbols and can't have spaces and commas and stuff.
# That will break if someone uses a DOT keyword as a property name, as they must be quoted.

function savedot(io::IO, g::AbstractMetaGraph)

    if is_directed(g)
        write(io, "digraph G {\n")
        dash = "->"
    else
        write(io, "graph G {\n")
        dash = "--"
    end

    for p in props(g)
        write(io, "$(p[1])=$(quote_prop(p[2]));\n")
    end

    for v in vertices(g)
        write(io, "$v")
        if length(props(g, v)) > 0
            write(io, " [ ")

            for p in props(g, v)
                write(io, "$(p[1])=$(quote_prop(p[2])), ")
            end

            write(io, "];")
        end
        write(io, "\n")
    end

    for e in edges(g)
        write(io, "$(src(e)) $dash $(dst(e)) [ ")
        for p in props(g,e)
            write(io, "$(p[1])=$(quote_prop(p[2])), ")
        end
        write(io, "]\n")
    end
    write(io, "}\n")
end

function savegraph(fn::AbstractString, g::AbstractMetaGraph, ::DOTFormat)
    open(fn, "w") do fp
        savedot(fp, g)
    end
end

function reverse(mg::MetaDiGraph{T,U}) where T <: Integer where U <: Real
    rg = reverse(mg.graph)
    map = nv(mg):-1:1
    rvprops = mg.vprops
    reprops = Dict{SimpleEdge{T},PropDict}()
    rgprops = mg.gprops
    rweightfield = mg.weightfield
    rdefaultweight = mg.defaultweight
    rindices = mg.indices

    for e in keys(mg.eprops)
        reprops[reverse(e)] = mg.eprops[e]
    end

    rmg = MetaDiGraph(rg,
        rvprops,
        reprops,
        rgprops,
        rweightfield,
        rdefaultweight,
        MetaDict(),
        Set{Symbol}())
    for p in mg.indices
        set_indexing_prop!(rmg, p)
    end

    return rmg
end

@testset "Persistence" begin
    (f, fio) = mktemp()
    close(fio)

    gx = path_graph(5)
    for g in testgraphs(gx)
        mg = MetaGraph(g)
        set_prop!(mg, 1, 2, :weight, 0.2)
        set_prop!(mg, 2, 3, :color, :red)
        set_prop!(mg, 1, :name, "Alice")
        set_prop!(mg, 2, :name, "Bob")
        set_prop!(mg, :type, "My MetaGraph")
    
        @test savegraph(f, mg) == 1
        g2 = loadgraph(f, MGFormat())
        @test mg == g2
    end

    gx = path_digraph(5)
    for g in testdigraphs(gx)
        mg = MetaDiGraph(g)
        set_prop!(mg, 1, 2, :weight, 0.2)
        set_prop!(mg, 2, 3, :color, :red)
        set_prop!(mg, 1, :name, "Alice")
        set_prop!(mg, 2, :name, "Bob")
        set_prop!(mg, :type, "My MetaGraph")

        @test savegraph(f, mg) == 1
        g2 = loadgraph(f, MGFormat())
        @test mg == g2        
    end
    rm(f)
end

@testset "Overrides" begin
    g=MetaDiGraph(star_digraph(4), 8)

    set_indexing_prop!(g,:nodelabel)
    foreach(v->set_indexing_prop!(g,v,:nodelabel,"Vertex $v"),vertices(g))
    foreach(e->set_prop!(g,e,:edgelabel,"Edge ($(e.src),$(e.dst))") ,edges(g))

    h=reverse(g)

    for v in 1:3
        @test get_prop(g, v, :nodelabel) == get_prop(h, v, :nodelabel)
    end

    for sd in 2:4
        @test get_prop(g, 1, sd, :edgelabel) == get_prop(h, sd, 1, :edgelabel) 
    end

    @test weightfield(h) == weightfield(g) == :weight
    @test defaultweight(h) == defaultweight(g) == 8

end

using Graphs
using MetaGraphs
using Test

import Graphs.SimpleGraphs: SimpleGraph, SimpleDiGraph

const testdir = @__DIR__

testgraphs(g) = [g, SimpleGraph{UInt8}(g), SimpleGraph{Int16}(g)]
testdigraphs(g) = [g, SimpleDiGraph{UInt8}(g), SimpleDiGraph{Int16}(g)]

const tests = [
    "metagraphs",
    "overrides",
    "persistence",
    "dotformat"
]

@testset "MetaGraphs" begin
    for t in tests
        tp = joinpath(testdir, "$(t).jl")
        include(tp)
    end
end

mutable struct MetaGraph{T <: Integer,U <: Real} <: AbstractMetaGraph{T}
    graph::SimpleGraph{T}
    vprops::Dict{T,PropDict}
    eprops::Dict{SimpleEdge{T},PropDict}
    gprops::PropDict
    weightfield::Symbol
    defaultweight::U
    metaindex::MetaDict
    indices::Set{Symbol}
end

function MetaGraph(x, weightfield::Symbol, defaultweight::U) where U <: Real
    T = eltype(x)
    g = SimpleGraph(x)
    vprops = Dict{T,PropDict}()
    eprops = Dict{SimpleEdge{T},PropDict}()
    gprops = PropDict()
    metaindex = MetaDict()
    idxs = Set{Symbol}()
    MetaGraph(g, vprops, eprops, gprops, weightfield, defaultweight, metaindex, idxs)
end

MetaGraph() = MetaGraph(SimpleGraph())
MetaGraph{T,U}() where T <: Integer where U <: Real = MetaGraph(SimpleGraph{T}(), one(U))
MetaGraph{T,U}(x::Integer) where T <: Integer where U <: Real = MetaGraph(T(x), :weight, U(1.0))
MetaGraph(x) = MetaGraph(x, :weight, 1.0)
MetaGraph(x, weightfield::Symbol) = MetaGraph(x, weightfield, 1.0)
MetaGraph(x, defaultweight::Real) = MetaGraph(x, :weight, defaultweight)

# converts MetaGraph{Int, Float64} to MetaGraph{UInt8, Float32}
function MetaGraph{T,U}(g::MetaGraph) where T <: Integer where U <: Real
    newg = SimpleGraph{T}(g.graph)
    return MetaGraph(newg, U(g.defaultweight))
end

function MetaGraph{T,U}(g::SimpleGraph, weightfield::Symbol=:weight, defaultweight::Real=1.0) where T <: Integer where U <: Real
    newg = SimpleGraph{T}(g)
    return MetaGraph(newg, weightfield, U(defaultweight))
end

function MetaGraph{T,U}(g::SimpleGraph, defaultweight::Real) where T <: Integer where U <: Real
    newg = SimpleGraph{T}(g)
    return MetaGraph(newg, :weight, U(defaultweight))
end

function MetaGraph(g::MetaDiGraph{T,U}) where T <: Integer where U <: Real
    return MetaGraph(Graph(g.graph), deepcopy(g.vprops), deepcopy(g.eprops), deepcopy(g.gprops), g.weightfield, g.defaultweight, deepcopy(g.metaindex), deepcopy(g.indices))
end

SimpleGraph(g::MetaGraph) = g.graph

is_directed(::Type{MetaGraph}) = false
is_directed(::Type{MetaGraph{T,U}}) where T where U = false
is_directed(g::MetaGraph) = false

weighttype(g::MetaGraph{T,U}) where T where U = U
function props(g::MetaGraph, _e::SimpleEdge)
    e = Graphs.is_ordered(_e) ? _e : reverse(_e)
    get(PropDict, g.eprops, e)
end

function set_props!(g::MetaGraph, _e::SimpleEdge, d::Dict)
    e = Graphs.is_ordered(_e) ? _e : reverse(_e)
    if has_edge(g, e)
        if !_hasdict(g, e)
            g.eprops[e] = d
        else
            merge!(g.eprops[e], d)
        end
        return true
    end
    return false
end

zero(g::MetaGraph{T,U}) where T where U = MetaGraph{T,U}(SimpleGraph{T}())

module MetaGraphs
using Graphs
using JLD2

import Base:
    eltype, show, ==, Pair,
    Tuple, copy, length, size,
    issubset, zero, getindex
import Random:
    randstring, seed!

import Graphs:
    AbstractGraph, src, dst, edgetype, nv,
    ne, vertices, edges, is_directed,
    add_vertex!, add_edge!, rem_vertex!, rem_edge!,
    has_vertex, has_edge, inneighbors, outneighbors,
    weights, indegree, outdegree, degree,
    induced_subgraph,
    loadgraph, savegraph, AbstractGraphFormat,
    reverse

import Graphs.SimpleGraphs:
    AbstractSimpleGraph, SimpleGraph, SimpleDiGraph,
    SimpleEdge, fadj, badj

export
    AbstractMetaGraph,
    MetaGraph,
    MetaDiGraph,
    weighttype,
    props,
    get_prop,
    set_props!,
    set_prop!,
    rem_prop!,
    has_prop,
    clear_props!,
    weightfield!,
    defaultweight!,
    weightfield,
    defaultweight,
    filter_edges,
    filter_vertices,
    MGFormat,
    DOTFormat,
    set_indexing_prop!,
    reverse

const PropDict = Dict{Symbol,Any}
const MetaDict = Dict{Symbol,Dict{Any,Integer}}

abstract type AbstractMetaGraph{T} <: AbstractGraph{T} end

function show(io::IO, g::AbstractMetaGraph)
    dir = is_directed(g) ? "directed" : "undirected"
    print(io, "{$(nv(g)), $(ne(g))} $dir $(eltype(g)) metagraph with $(weighttype(g)) weights defined by :$(g.weightfield) (default weight $(g.defaultweight))")
end

@inline fadj(g::AbstractMetaGraph, x...) = fadj(g.graph, x...)
@inline badj(g::AbstractMetaGraph, x...) = badj(g.graph, x...)


eltype(g::AbstractMetaGraph) = eltype(g.graph)
edgetype(g::AbstractMetaGraph) = edgetype(g.graph)
nv(g::AbstractMetaGraph) = nv(g.graph)
vertices(g::AbstractMetaGraph) = vertices(g.graph)

ne(g::AbstractMetaGraph) = ne(g.graph)
edges(g::AbstractMetaGraph) = edges(g.graph)

has_vertex(g::AbstractMetaGraph, x...) = has_vertex(g.graph, x...)
@inline has_edge(g::AbstractMetaGraph, x...) = has_edge(g.graph, x...)

inneighbors(g::AbstractMetaGraph, v::Integer) = inneighbors(g.graph, v)
outneighbors(g::AbstractMetaGraph, v::Integer) = fadj(g.graph, v)

issubset(g::T, h::T) where {T<:AbstractMetaGraph} = issubset(g.graph, h.graph)

"""
    add_edge!(g, u, v, s, val)
    add_edge!(g, u, v, d)

    Add an edge `(u, v)` to MetaGraph `g` with optional property `s` having value `val`,
    or properties given by an optional dictionary `d` mapping symbols to values.

    return true if the edge has been added, false otherwise
"""
@inline add_edge!(g::AbstractMetaGraph, x...) = add_edge!(g.graph, x...)
function add_edge!(g::AbstractMetaGraph, u::Integer, v::Integer, s::Symbol, val)
    add_edge!(g, u, v) || return false
    set_prop!(g, u, v, s, val)
    return true
end

function add_edge!(g::AbstractMetaGraph, u::Integer, v::Integer, d::Dict)
    add_edge!(g, u, v) || return false
    set_props!(g, u, v, d)
    return true
end

@inline function rem_edge!(g::AbstractMetaGraph, x...)
    clear_props!(g, x...)
    rem_edge!(g.graph, x...)
end


"""
    add_vertex!(g)
    add_vertex!(g, s, v)
    add_vertex!(g, d)

    Add a vertex to MetaGraph `g` with optional property `s` having value `v`,
    or properties given by an optional Dicitionary `d` mapping symbols to values.

    return true if the vertex has been added, false otherwise.
"""
add_vertex!(g::AbstractMetaGraph) = add_vertex!(g.graph)
function add_vertex!(g::AbstractMetaGraph, d::Dict)
    add_vertex!(g) || return false
    set_props!(g, nv(g), d)
    return true
end

function add_vertex!(g::AbstractMetaGraph, s::Symbol, v)
    add_vertex!(g) || return false
    set_prop!(g, nv(g), s, v)
    return true
end

function rem_vertex!(g::AbstractMetaGraph, v::Integer)
    v in vertices(g) || return false
    lastv = nv(g)
    lastvprops = props(g, lastv)

    lasteoutprops = Dict(n => props(g, lastv, n) for n in outneighbors(g, lastv))
    lasteinprops = Dict(n => props(g, n, lastv) for n in inneighbors(g, lastv))
    for ind in g.indices
        if haskey(props(g, lastv), ind)
            pop!(g.metaindex[ind], get_prop(g, lastv, ind))
        end
        if haskey(props(g, v), ind)
            v != lastv && pop!(g.metaindex[ind], get_prop(g, v, ind))
        end
    end
    clear_props!(g, v)
    for n in outneighbors(g, lastv)
        clear_props!(g, lastv, n)
    end

    for n in inneighbors(g, lastv)
        clear_props!(g, n, lastv)
    end
    if v != lastv # ignore if we're removing the last vertex.
        for n in outneighbors(g, v)
            clear_props!(g, v, n)
        end
        for n in inneighbors(g, v)
            clear_props!(g, n, v)
        end
    end
    clear_props!(g, lastv)
    retval = rem_vertex!(g.graph, v)
    retval || return false
    if v != lastv # ignore if we're removing the last vertex.
        for (key, val) in lastvprops
            if key in g.indices
                set_indexing_prop!(g, v, key, val)
            else
                set_prop!(g, v, key, val)
            end
        end

        # Map property keys to new node values
        if lastv in keys(lasteoutprops)
            lasteoutprops[v] = lasteoutprops[lastv]
            delete!(lasteoutprops, lastv)
        end
        if lastv in keys(lasteinprops)
            lasteinprops[v] = lasteinprops[lastv]
            delete!(lasteinprops, lastv)
        end

        for n in outneighbors(g, v)
            set_props!(g, v, n, lasteoutprops[n])
        end

        for n in inneighbors(g, v)
            set_props!(g, n, v, lasteinprops[n])
        end
    end
    return true
end

struct MetaWeights{T<:Integer,U<:Real} <: AbstractMatrix{U}
    n::T
    weightfield::Symbol
    defaultweight::U
    eprops::Dict{SimpleEdge{T},PropDict}
    directed::Bool
end
show(io::IO, x::MetaWeights) = print(io, "metaweights")
show(io::IO, z::MIME"text/plain", x::MetaWeights) = show(io, x)

MetaWeights(g::AbstractMetaGraph) = MetaWeights{eltype(g),eltype(g.defaultweight)}(nv(g), g.weightfield, g.defaultweight, g.eprops, is_directed(g))

function getindex(w::MetaWeights{T,U}, u::Integer, v::Integer)::U where {T<:Integer} where {U<:Real}
    _e = Edge(u, v)
    e = !w.directed && !Graphs.is_ordered(_e) ? reverse(_e) : _e
    !haskey(w.eprops, e) && return w.defaultweight
    return U(get(w.eprops[e], w.weightfield, w.defaultweight))
end

function getindex(g::AbstractMetaGraph, prop::Symbol)
    !haskey(g.metaindex, prop) && error("':$prop' is not an index")
    return g.metaindex[prop]
end

function getindex(g::AbstractMetaGraph, indx::Any, prop::Symbol)
    !haskey(g, indx, prop) && error("No node with prop $prop and key $indx")
    return g.metaindex[prop][indx]
end

function Base.haskey(g::AbstractMetaGraph, indx::Any, prop::Symbol)
    haskey(g.metaindex, prop) || error("':$prop' is not an index")
    typeof(indx) <: eltype(keys(g.metaindex[prop])) || error("Index type does not match keys of metaindex '$prop'")
    return haskey(g.metaindex[prop], indx)
end

function getindex(g::AbstractMetaGraph, indx::Integer, prop::Symbol)
    haskey(g.metaindex, prop) || error("':$prop' is not an index")
    return props(g, indx)[prop]
end

size(d::MetaWeights) = (d.n, d.n)

weights(g::AbstractMetaGraph) = MetaWeights(g)

_hasdict(g::AbstractMetaGraph, v::Integer) = haskey(g.vprops, v)
_hasdict(g::AbstractMetaGraph, e::SimpleEdge) = haskey(g.eprops, e)

"""
    props(g)
    props(g, v)
    props(g, e)
    props(g, s, d)

Return a dictionary of all metadata from graph `g`, vertex `v`, or edge `e`
(optionally referenced by source vertex `s` and destination vertex `d`).
"""
props(g::AbstractMetaGraph) = g.gprops
props(g::AbstractMetaGraph, v::Integer) = get(PropDict, g.vprops, v)
# props for edges is dependent on directedness.
props(g::AbstractMetaGraph, u::Integer, v::Integer) = props(g, Edge(u, v))

"""
    get_prop(g, prop::Symbol)
    get_prop(g, prop::Symbol, default)

    get_prop(g, v, prop::Symbol)
    get_prop(g, v, prop::Symbol, default)

    get_prop(g, e, prop::Symbol)
    get_prop(g, e, prop::Symbol, default)
    get_prop(g, s, d, prop::Symbol)
    get_prop(g, s, d, prop::Symbol, default)

Return the property `prop` defined for graph `g`, vertex `v`, or edge `e`
(optionally referenced by source vertex `s` and destination vertex `d`).
Use the version with `default`, to return a default value if the property is not defined. Otherwise, it will return an error.
"""
get_prop(g::AbstractMetaGraph, prop::Symbol) = props(g)[prop]
get_prop(g::AbstractMetaGraph, prop::Symbol, default) = get(props(g), prop, default)

get_prop(g::AbstractMetaGraph, v::Integer, prop::Symbol) = props(g, v)[prop]
get_prop(g::AbstractMetaGraph, v::Integer, prop::Symbol, default) = get(props(g, v), prop, default)

get_prop(g::AbstractMetaGraph, e::SimpleEdge, prop::Symbol) = props(g, e)[prop]
get_prop(g::AbstractMetaGraph, e::SimpleEdge, prop::Symbol, default) = get(props(g, e), prop, default)

get_prop(g::AbstractMetaGraph, u::Integer, v::Integer, prop::Symbol) = get_prop(g, Edge(u, v), prop)
get_prop(g::AbstractMetaGraph, u::Integer, v::Integer, prop::Symbol, default) = get_prop(g, Edge(u, v), prop, default)


"""
    has_prop(g, prop)
    has_prop(g, v, prop)
    has_prop(g, e, prop)
    has_prop(g, s, d, prop)

Return true if the property `prop` is defined for graph `g`, vertex `v`, or
edge `e` (optionally referenced by source vertex `s` and destination vertex `d`).
"""
has_prop(g::AbstractMetaGraph, prop::Symbol) = haskey(g.gprops, prop)
has_prop(g::AbstractMetaGraph, v::Integer, prop::Symbol) = haskey(props(g, v), prop)
has_prop(g::AbstractMetaGraph, e::SimpleEdge, prop::Symbol) = haskey(props(g, e), prop)

has_prop(g::AbstractMetaGraph, u::Integer, v::Integer, prop::Symbol) = has_prop(g, Edge(u, v), prop)

"""
    set_props!(g, dict)
    set_props!(g, v, dict)
    set_props!(g, e, dict)
    set_props!(g, s, d, dict)

Bulk set (merge) properties contained in `dict` with graph `g`, vertex `v`, or
edge `e` (optionally referenced by source vertex `s` and destination vertex `d`).
Will return false if vertex or edge does not exist.
"""
function set_props!(g::AbstractMetaGraph, d::Dict)
    merge!(g.gprops, d)
    return true
end

function set_props!(g::AbstractMetaGraph, v::Integer, d::Dict)
    if has_vertex(g, v)
        for (prop, val) in d
            index_available(g, v, prop, val) || error("':$prop' index already contains $val")
        end
        if !_hasdict(g, v)
            g.vprops[v] = d
        else
            merge!(g.vprops[v], d)
        end
        for prop in intersect(keys(d), g.indices)
            g.metaindex[prop][d[prop]] = v
        end
        return true
    end
    return false
end
# set_props!(g::AbstractMetaGraph, e::SimpleEdge, d::Dict) is dependent on directedness.

set_props!(g::AbstractMetaGraph{T}, u::Integer, v::Integer, d::Dict) where {T} = set_props!(g, Edge(T(u), T(v)), d)

"""
    set_prop!(g, prop, val)
    set_prop!(g, v, prop, val)
    set_prop!(g, e, prop, val)
    set_prop!(g, s, d, prop, val)

Set (replace) property `prop` with value `val` in graph `g`, vertex `v`, or
edge `e` (optionally referenced by source vertex `s` and destination vertex `d`).
Will return false if vertex or edge does not exist, true otherwise.
"""
set_prop!(g::AbstractMetaGraph, prop::Symbol, val) = set_props!(g, Dict(prop => val))
set_prop!(g::AbstractMetaGraph, v::Integer, prop::Symbol, val) = begin
    if in(prop, g.indices)
        set_indexing_prop!(g, v, prop, val)
    else
        set_props!(g, v, Dict(prop => val))
    end
end
set_prop!(g::AbstractMetaGraph, e::SimpleEdge, prop::Symbol, val) = set_props!(g, e, Dict(prop => val))

set_prop!(g::AbstractMetaGraph{T}, u::Integer, v::Integer, prop::Symbol, val) where {T} = set_prop!(g, Edge(T(u), T(v)), prop, val)

"""
    rem_prop!(g, prop)
    rem_prop!(g, v, prop)
    rem_prop!(g, e, prop)
    rem_prop!(g, s, d, prop)

Remove property `prop` from graph `g`, vertex `v`, or edge `e`
(optionally referenced by source vertex `s` and destination vertex `d`).
If property, vertex, or edge does not exist, will not do anything.
"""
rem_prop!(g::AbstractMetaGraph, prop::Symbol) = delete!(g.gprops, prop)
rem_prop!(g::AbstractMetaGraph, v::Integer, prop::Symbol) = delete!(g.vprops[v], prop)
rem_prop!(g::AbstractMetaGraph, e::SimpleEdge, prop::Symbol) = delete!(g.eprops[e], prop)

rem_prop!(g::AbstractMetaGraph{T}, u::Integer, v::Integer, prop::Symbol) where {T} = rem_prop!(g, Edge(T(u), T(v)), prop)

"""
    default_index_value(v, prop, index_values; exclude=nothing)

Provides a default index value for a vertex if no value currently exists. The default is a string: "\$prop\$i" where `prop` is the property name and `i` is the vertex number. If some other vertex already has this name, a randomized string is generated (though the way it is generated is deterministic).
"""
function default_index_value(v::Integer, prop::Symbol, index_values::Set{Any}; exclude=nothing)
    val = string(prop) * string(v)
    if in(val, index_values) || val == exclude
        seed!(v + hash(prop))
        val = randstring()
        @warn("'$(string(prop))$v' is already in index, setting ':$prop' for vertex $v to $val")
    end
    return val
end

"""
    index_available(g, v, prop, val)

Check whether `prop` with `val` is available to be used as indexing for node `v`.
First check whether `prop` is already an index. If not, check whether `val`
already appears as an index in any node. If not, finally check whether `prop`
and `val` indeed describe a property of node `v`.
"""
function index_available(g::AbstractMetaGraph, v::Integer, prop::Symbol, val::Any)
    !in(prop, g.indices) || !haskey(g.metaindex[prop], val) || (haskey(g.vprops, v) && haskey(g.vprops[v], prop) && g.vprops[v][prop] == val)
end
"""
    set_indexing_prop!(g, prop)
    set_indexing_prop!(g, v, prop, val)

Make property `prop` into an indexing property. If any values for this property
are already set, each vertex must have unique values. Optionally, set the index
`val` for vertex `v`. Any vertices without values will be set to a default
("(prop)(v)").
"""
function set_indexing_prop!(g::AbstractMetaGraph, prop::Symbol; exclude=nothing)
    in(prop, g.indices) && return g.indices
    index_values = [g.vprops[v][prop] for v in keys(g.vprops) if haskey(g.vprops[v], prop)]
    length(index_values) != length(union(index_values)) && error("Cannot make $prop an index, duplicate values detected")
    index_values = Set(index_values)

    g.metaindex[prop] = Dict{Any,Integer}()
    for v in vertices(g)
        if !haskey(g.vprops, v) || !haskey(g.vprops[v], prop)
            val = default_index_value(v, prop, index_values, exclude=exclude)
            set_prop!(g, v, prop, val)
        end
        g.metaindex[prop][g.vprops[v][prop]] = v
    end
    push!(g.indices, prop)
    return g.indices
end

function set_indexing_prop!(g::AbstractMetaGraph, v::Integer, prop::Symbol, val::Any)
    !in(prop, g.indices) && set_indexing_prop!(g, prop, exclude=val)
    (haskey(g.metaindex[prop], val) && haskey(g.vprops, v) && haskey(g.vprops[v], prop) && g.vprops[v][prop] == val) && return g.indices
    haskey(g.metaindex[prop], val) && error("':$prop' index already contains $val")

    if !haskey(g.vprops, v)
        push!(g.vprops, v => Dict{Symbol,Any}())
    end
    if haskey(g.vprops[v], prop)
        delete!(g.metaindex[prop], g.vprops[v][prop])
    end
    g.metaindex[prop][val] = v
    g.vprops[v][prop] = val
    return g.indices
end
"""
    clear_props!(g)
    clear_props!(g, v)
    clear_props!(g, e)
    clear_props!(g, s, d)

Remove all defined properties from graph `g`, vertex `v`, or edge `e`
(optionally referenced by source vertex `s` and destination vertex `d`).
"""
clear_props!(g::AbstractMetaGraph, v::Integer) = _hasdict(g, v) && delete!(g.vprops, v)
clear_props!(g::AbstractMetaGraph, e::SimpleEdge) = _hasdict(g, e) && delete!(g.eprops, e)
clear_props!(g::AbstractMetaGraph) = g.gprops = PropDict()

clear_props!(g::AbstractMetaGraph{T}, u::Integer, v::Integer) where {T} = clear_props!(g, Edge(T(u), T(v)))

"""
    weightfield!(g, prop)

Set the field that contains weight information to `prop`.
"""
weightfield!(g::AbstractMetaGraph, prop::Symbol) = (g.weightfield = prop)

"""
    weightfield(g)

Return the field that contains weight information for metagraph `g`.
"""
weightfield(g::AbstractMetaGraph) = g.weightfield

"""
    defaultweight!(g, weight)

Set the default weight for metagraph `g`
"""
defaultweight!(g::AbstractMetaGraph, weight::Real) =
    g.defaultweight = weight
"""
    defaultweight(g)

Return the default weight for metagraph `g`.
"""
defaultweight(g::AbstractMetaGraph) = g.defaultweight

"""
    filter_edges(g, prop[, val])
    filter_edges(g, fn)

Return an iterator to all edges that have property `prop` defined (optionally
as `val`), or where function `fn` returns `true` only for edges that should be
included in the iterator.

`fn` should be of the form
```
fn(g::AbstractMetaGraph{T}, e::SimpleEdge{T})::Boolean
```
where `e` is replaced with the edge being evaluated.
"""
filter_edges(g::AbstractMetaGraph, fn::Function) =
    Iterators.filter(e -> fn(g, e), edges(g))

filter_edges(g::AbstractMetaGraph, prop::Symbol) =
    filter_edges(g, (g, e) -> has_prop(g, e, prop))

filter_edges(g::AbstractMetaGraph, prop::Symbol, val) =
    filter_edges(g, (g, e) -> has_prop(g, e, prop) && get_prop(g, e, prop) == val)

"""
    filter_vertices(g, prop[, val])
    filter_vertices(g, fn)

Return an iterator to all vertices that have property `prop` defined (optionally
as `val`), or where function `fn` returns `true` only for vertices that should be
included in the iterator.

`fn` should be of the form
```
fn(g::AbstractMetaGraph, v::Integer)::Boolean
```
where `v` is replaced with the vertex being evaluated.
"""
filter_vertices(g::AbstractMetaGraph, fn::Function) =
    Iterators.filter(x -> fn(g, x), vertices(g))

filter_vertices(g::AbstractMetaGraph, prop::Symbol) =
    filter_vertices(g, (g, x) -> has_prop(g, x, prop))

filter_vertices(g::AbstractMetaGraph, prop::Symbol, val) =
    filter_vertices(g, (g, x) -> has_prop(g, x, prop) && get_prop(g, x, prop) == val)

function _copy_props!(oldg::T, newg::T, vmap) where {T<:AbstractMetaGraph}
    for (newv, oldv) in enumerate(vmap)
        p = props(oldg, oldv)
        if !isempty(p)
            set_props!(newg, newv, p)
        end
    end
    for newe in edges(newg)
        u, v = Tuple(newe)
        olde = Edge(vmap[u], vmap[v])
        if !is_directed(oldg) && !is_ordered(olde)
            olde = reverse(olde)
        end
        p = props(oldg, olde)
        if !isempty(p)
            set_props!(newg, newe, p)
        end
    end
    if !isempty(oldg.gprops)
        set_props!(newg, oldg.gprops)
    end
    defaultweight!(newg, defaultweight(oldg))
    weightfield!(newg, weightfield(oldg))
    return nothing
end

function induced_subgraph(g::T, v::AbstractVector{U}) where {T<:AbstractMetaGraph} where {U<:Integer}
    inducedgraph, vmap = induced_subgraph(g.graph, v)
    newg = T(inducedgraph)
    _copy_props!(g, newg, vmap)
    return newg, vmap
end

function induced_subgraph(g::T, v::AbstractVector{U}) where {T<:AbstractMetaGraph} where {U<:SimpleEdge}
    inducedgraph, vmap = induced_subgraph(g.graph, v)
    newg = T(inducedgraph)
    _copy_props!(g, newg, vmap)
    return newg, vmap
end

induced_subgraph(g::T, filt::Iterators.Filter) where {T<:AbstractMetaGraph} =
    induced_subgraph(g, collect(filt))

# TODO - would be nice to be able to apply a function to properties. Not sure
# how this might work, but if the property is a vector, a generic way to append to
# it would be a good thing.

==(x::AbstractMetaGraph, y::AbstractMetaGraph) = x.graph == y.graph

copy(g::T) where {T<:AbstractMetaGraph} = deepcopy(g)

include("metadigraph.jl")
include("metagraph.jl")
include("persistence.jl")
include("overrides.jl")
end # module

# MetaGraphs
Metadata for graphs is stored as a series of named key-value pairs, with the
key being an instance of type `Symbol` and the value being any type. The following methods are available for MetaGraphs:

```@autodocs
Modules = [MetaGraphs]
Pages   = [
    "MetaGraphs.jl",
    "metagraph.jl",
    "metadigraph.jl"
]
Private = false
```
